Bug 1666590 - incrond multiply processes
Summary: incrond multiply processes
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora EPEL
Classification: Fedora
Component: incron
Version: epel7
Hardware: x86_64
OS: Linux
unspecified
high
Target Milestone: ---
Assignee: Kevin Fenzi
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2019-01-16 06:20 UTC by Dmitry Melekhov
Modified: 2019-04-06 20:17 UTC (History)
7 users (show)

Fixed In Version: incron-0.5.12-11.fc30 incron-0.5.12-11.fc29 incron-0.5.12-11.fc28 incron-0.5.12-11.el7
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2019-03-29 19:18:47 UTC


Attachments (Terms of Use)
script for run from incrond (1.82 KB, text/x-python)
2019-01-16 06:20 UTC, Dmitry Melekhov
no flags Details

Description Dmitry Melekhov 2019-01-16 06:20:50 UTC
Created attachment 1520881 [details]
script for run from incrond

Description of problem:

I run incrond to store connections info from openvpn using this:

/etc/openvpn/openvpn-status.log IN_MODIFY /usr/local/bin/openvpn.py

I'll attach python script.

Everything was fine while I run Centos 6 and EPEL 6 with 
incrond 0.5.9

But EPEL7 has 
incrond 0.5.12

And after each run it starts additional incrond process, thus, finally it eats all RAM

Version-Release number of selected component (if applicable):

incrond 0.5.12


How reproducible:


Steps to Reproduce:
1.

create incron entry
/etc/openvpn/openvpn-status.log IN_MODIFY /usr/local/bin/openvpn.py

2.
change /etc/openvpn/openvpn-status.log ( it changes while openvpn server runs)


Actual results:

+1 incrond process on each run

Expected results:

one incrond process


Additional info:

incrond 0.5.9 from EPEL 6 runs on Centos6 without problems.

Comment 1 Dmitry Melekhov 2019-01-16 06:31:36 UTC
Sorry, I wanted to write


incrond 0.5.9 from EPEL 6 runs on Centos7.6 without problems.

Comment 2 Kevin Fenzi 2019-01-16 17:32:02 UTC
Please try incron-0.5.12-9.el7 from epel-testing.

Comment 3 Dmitry Melekhov 2019-01-16 17:34:08 UTC
Unfortunately, I have the same problem with incron-0.5.12-9.el7
Thank you!

Comment 4 Jay Leafey 2019-01-16 18:43:40 UTC
Just out of curiosity, was your incron entry in a "user" incrontab or in the "system" incrontab, i.e. in a file in /etc/incrond.d/?  I have been told that they behave a bit differently by one of my users, with the system incrontab entries resulting in dangling incrond processes but user incrontab entries behaving as expected.  I have not had a chance to test this yet so I can't say for sure that this is relevant to your issue, but it may be worth looking at.

Comment 5 Dmitry Melekhov 2019-01-17 04:54:50 UTC
yes, entry is in system incrontab, and yes, moving it to user incrontab solves problem.
thank you!

Comment 6 IPGGroup Infra Team 2019-03-13 05:59:14 UTC
Hi Kevin,

We have been facing this issue for the last couple of days on our dev environments.
We've been waiting for this version to fix the defunct issue with the package 0.5.12.6.el7 (Bug 1656939)

But the package 0.5.12.9.el7 is no longer generating defunct process, but a bunch of incrond processes.
So we have rollback to the latest stable version 0.5.10.8.el7.

To reply to the comment #4, we are also using the system incrontabs to manage multiple incrontabs.
But we do not have the possibility to merge them all in a single file and attached it to a user (root in our case).
The incrontabs are managed by different Puppet modules and are deployed to our servers based of their profile.
This means that some servers have multiples files in the /etc/incron.d/ folder managing different layers of log/dump files for our applications.

Is there any other way to avoid the multiplication of the incrond process ?


Kind Regards,
Vincent Lours
IPG Group Pty Ltd.

Comment 7 Fedora Admin XMLRPC Client 2019-03-17 04:07:21 UTC
There's a possible fix upstream: https://github.com/ar-/incron/pull/56

Can any affected parities test this scratch build: 
https://koji.fedoraproject.org/koji/taskinfo?taskID=33556097

Comment 8 IPGGroup Infra Team 2019-03-18 02:10:03 UTC
Hi there,

First of all, Thanks for the quick reply and the patch.

I've deployed the update to three servers in our no-critical environments.
So far (after 1h) incrond is still working and not generating any permanent new child process, from the small tests I've done.

I should be able to confirm the fix in the few next days, as we should have some application batches running overnight.

For your records, one of the updated server had more than 12K incron processes running on this morning.

Cheers,
Vincent

Comment 9 Dmitry Melekhov 2019-03-18 04:36:33 UTC
Applied patch from https://github.com/ar-/incron/pull/56  to 0.5.12-9.
Everything is fine now in my environment.

Thank you!

Comment 10 Fedora Admin XMLRPC Client 2019-03-18 17:41:58 UTC
great. I'll push an update to testing then... thanks for testing this out!

Comment 11 IPGGroup Infra Team 2019-03-18 22:26:03 UTC
Hi there,

In the last 24H, one of the test server ran more than 10K incron commands without any issue (no defunct & still only 1 incrond process).

Upgrade 0.5.12-10 works great.
Waiting to get it available in the Epel repos.

Thanks for your help.

Cheers,
Vincent

Comment 12 Fedora Update System 2019-03-20 22:21:36 UTC
incron-0.5.12-11.el7 has been submitted as an update to Fedora EPEL 7. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2019-1502b7bc8f

Comment 13 Fedora Update System 2019-03-20 22:21:41 UTC
incron-0.5.12-11.fc30 has been submitted as an update to Fedora 30. https://bodhi.fedoraproject.org/updates/FEDORA-2019-ae0dbc9c03

Comment 14 Fedora Update System 2019-03-20 22:21:52 UTC
incron-0.5.12-11.fc28 has been submitted as an update to Fedora 28. https://bodhi.fedoraproject.org/updates/FEDORA-2019-4228013e5a

Comment 15 Fedora Update System 2019-03-20 22:22:01 UTC
incron-0.5.12-11.fc29 has been submitted as an update to Fedora 29. https://bodhi.fedoraproject.org/updates/FEDORA-2019-594e664ae4

Comment 16 Fedora Update System 2019-03-21 19:12:24 UTC
incron-0.5.12-11.fc30 has been pushed to the Fedora 30 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2019-ae0dbc9c03

Comment 17 Fedora Update System 2019-03-21 21:19:00 UTC
incron-0.5.12-11.fc29 has been pushed to the Fedora 29 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2019-594e664ae4

Comment 18 Fedora Update System 2019-03-21 21:48:56 UTC
incron-0.5.12-11.fc28 has been pushed to the Fedora 28 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2019-4228013e5a

Comment 19 Fedora Update System 2019-03-21 21:52:42 UTC
incron-0.5.12-11.el7 has been pushed to the Fedora EPEL 7 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2019-1502b7bc8f

Comment 20 Fedora Update System 2019-03-29 19:18:47 UTC
incron-0.5.12-11.fc30 has been pushed to the Fedora 30 stable repository. If problems still persist, please make note of it in this bug report.

Comment 21 Fedora Update System 2019-03-29 21:03:38 UTC
incron-0.5.12-11.fc29 has been pushed to the Fedora 29 stable repository. If problems still persist, please make note of it in this bug report.

Comment 22 Fedora Update System 2019-03-29 22:11:08 UTC
incron-0.5.12-11.fc28 has been pushed to the Fedora 28 stable repository. If problems still persist, please make note of it in this bug report.

Comment 23 Fedora Update System 2019-04-06 20:17:07 UTC
incron-0.5.12-11.el7 has been pushed to the Fedora EPEL 7 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.